module main;
  wire clk, reset;

  wire [15:0] in;
  wire in_srdy, in_drdy;
  wire [15:0] out;
  wire out_srdy, out_drdy;

  wire [4:0] n = 5'd2;
  wire [3:0] shift = 4'd8;

  clk_reset_gen _clk_reset_gen(clk, reset);

  source _source(clk, reset, in, in_srdy, in_drdy);

  sink _sink(clk, reset, out, out_srdy, out_drdy);

  bit_pack bitpack(clk, reset,
    in, in_srdy, in_drdy, n, shift,
    out, out_srdy, out_drdy);
endmodule

module clk_reset_gen(clk, reset);
  output clk;
  output reset;
  reg clk;
  reg reset;
  initial begin
    reset = 1;
    clk = 1;
    #5;
    clk = 0;
    #5;
    clk = 1;
    #5;
    reset = 0;
    clk = 0;
    forever #5 clk = ~clk;
  end
endmodule

module source(clk, reset, in, in_srdy, in_drdy);
  input clk, reset;
  output [15:0] in;
  output in_srdy;
  input in_drdy;

  reg [15:0] in;
  reg in_srdy;

  integer fp;
  integer t1,t2;

  initial begin
    fp = $fopen("bits.in","r");
    t1 = $fgetc(fp);
    t2 = $fgetc(fp);
    in = (t1<<8)|t2;
  end

  always @(posedge clk)
    if (reset)
      in_srdy <= #1 0;
    else begin
      in_srdy <= #1 $random;
//      in_srdy <= #1 $random | $random | $random;
      if (in_srdy && in_drdy) begin
        #2;
        t1 = $fgetc(fp);
        if (t1==(-1))
          $finish;
        t2 = $fgetc(fp);
        in = (t1<<8)|t2;
      end
    end

endmodule

module sink(clk, reset, out, out_srdy, out_drdy);
  input clk, reset;
  input [15:0] out;
  input out_srdy;
  output out_drdy;

  reg out_drdy;

  always @(posedge clk)
    if (reset)
      out_drdy <= #1 0;
    else begin
      out_drdy <= #1 $random;
//      out_drdy <= #1 $random & $random & $random;
//      out_drdy <= #1 $random | $random | $random;
      if (out_srdy && out_drdy)
        $display("%x",out);
    end

endmodule
